//#pragma comment(lib, "winmm.lib")
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

void OpenCloseDrive(char *cDrive, BOOL bOpen) {
	MCI_OPEN_PARMS mciParams;
	DWORD dwFlags = MCI_OPEN_TYPE | MCI_OPEN_TYPE_ID | MCI_OPEN_ELEMENT | MCI_OPEN_SHAREABLE;

	ZeroMemory(&mciParams, sizeof(MCI_OPEN_PARMS));
	mciParams.lpstrDeviceType = (LPCSTR)MCI_DEVTYPE_CD_AUDIO;
	mciParams.lpstrElementName = cDrive;

	if (!mciSendCommand(0, MCI_OPEN, dwFlags, (DWORD_PTR)&mciParams)) {
		mciSendCommand(mciParams.wDeviceID, MCI_SET, (bOpen ? MCI_SET_DOOR_OPEN : MCI_SET_DOOR_CLOSED), 0);
		mciSendCommand(mciParams.wDeviceID, MCI_CLOSE, MCI_WAIT, 0);
	}
}

int main(int argc, char *argv[]) {
	BOOL bSuccess = FALSE;
	char cDrive[3] = "?:";
	BOOL bOpen = -1;	// "undefiniert"

	if (argc == 3) {
		// 1.Parameter: open|close
		if (stricmp(argv[1], "open") == 0)
			bOpen = TRUE;
		else if (stricmp(argv[1], "close") == 0)
			bOpen = FALSE;
		// 2.Parameter: Laufwerksbuchstabe[:]
		cDrive[0] = argv[2][0];
		if ((cDrive[0] >= 'a') && (cDrive[0] <= 'z'))
			cDrive[0] = cDrive[0] - 32;

		if ((bOpen != -1) &&
			((cDrive[0] >= 'A') && (cDrive[0] <= 'Z')) &&
			((strlen(argv[2]) == 1) || ((strlen(argv[2]) == 2) && (argv[2][1] == ':'))))
			bSuccess = TRUE;
	}

	if (!bSuccess) {
		printf("AUFRUF: %s open|close CD-ROM-Laufwerksbuchstabe\n", argv[0]);
		printf("\tBeispiel: %s open D:\n", argv[0]);
		return EXIT_FAILURE;
	}

	OpenCloseDrive(cDrive, bOpen);

	return EXIT_SUCCESS;
}
